
import requests
from bs4 import BeautifulSoup
import pandas as pd
import re 

# le proxy ne sert pas hors de l'env insee

# http_proxy  = ""
# https_proxy = ""
# ftp_proxy   = ""

# proxyDict = {
# 	"http": http_proxy,
# 	"https": https_proxy,
# 	"ftp": ftp_proxy
# }

proxyDict = None

#,"window-size":"1920,1080"
headers = {
	'User-Agent': 'INS - collecte expérimentale sans but de diffusion - Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:109.0) Gecko/20100101 Firefox/115.0', 'Accept-Language': 'fr',"window-size":"1920,1080"}


# right click => tout copier
myobj = {
	"rech_cod_pay": "TN",
	"rech_cod_pay_new_value": "false",
	"rech_cod_reg": "104",
	"rech_cod_reg_new_value": "false",
	"rech_cod_vil": "",
	"rech_cod_vil_new_value": "true",
	"rech_cod_loc": "",
	"rech_cod_loc_new_value": "true",
	"rech_cod_rub": "",
	"rech_cod_rub_new_value": "true",
	"rech_cod_typ": "",
	"rech_cod_typ_new_value": "true",
	"rech_cod_sou_typ": "",
	"rech_cod_sou_typ_new_value": "true",
	"rech_cod_ann": "",
	"rech_prix_min": "",
	"rech_prix_max": "",
	"rech_surf_min": "",
	"rech_surf_max": "",
	"rech_typ_cli": ""
}


##avoir en entrée une liste 
requeteGet="http://www.tunisie-annonce.com/AnnoncesImmobilier.asp"
requetePost="http://www.tunisie-annonce.com/AnnoncesImmobilier.asp?rech_order_by=31"

# avec get
# response = requests.get(url=requeteGet, proxies=proxyDict, headers=headers)


# la requete post :
response = requests.post(url=requetePost, proxies=proxyDict, headers=headers, data = myobj)
response.close()

soup = BeautifulSoup(response.text, 'html.parser')
f = open("code_html.txt", "w", encoding="utf-8")
f.write(response.text)
f.close()


def extraire_nombre_annonces(a):
	tableau=a.find_all("table",attrs={"class":"RecordsNumber"})[0]
	texte=tableau.find_all("b")[0].text
	resultat=0
	if "annonces" in texte:
			resultat=re.findall(r'\d+', texte)[0]
	return resultat


#print(extraire_nombre_annonces(soup))


def extraire_nom_colonnes(soup):
	headers=soup.find_all("tr", attrs={"class":"Entete1"})[0]
	noms_colonnes=headers.find_all("td")
	colonnes=[]
	for n in noms_colonnes:
		if n.get_text(strip=True)!='' and n.get_text(strip=True) not in colonnes:
			colonnes.append(n.get_text(strip=True))
	return(colonnes)


#print(extraire_nom_colonnes(soup))


def extraire_donnees_tableau(soup,colonnes):
	liste_lignes = soup.find_all("tr", attrs={"class":"Tableau1"})
	print(len(liste_lignes))
	
	table_page1 = []
	for l in liste_lignes:
		donnees=l.find_all("td")
		a=0
		dic={}
		for j in range(len(donnees)):
			if(donnees[j].text):
				dic[colonnes[a]]=donnees[j].text
				a=a+1
		table_page1.append(dic)
	df=pd.DataFrame(table_page1,columns =colonnes)
	print(df)
	df.to_csv('resultat.csv')

print(extraire_donnees_tableau(soup,extraire_nom_colonnes(soup)))
